#ifndef _NABC_h
#define _NABC_h

typedef enum {data, nodata} data_type;  /* did we see a target or not?*/

typedef enum {invalid, initializing, tracking,predicting,timed_out} filter_activity;

/* Jesu Christu!  the bastard GLOBALIZED the fucking filter components.
what a bloody TURKEY!!!  C++ for me! dammit...growl snarl....*/

/* states filter gets into automatically while running so you can snooop on it
below struct strictly for minimizing number of parameters in setting up filter*/

typedef struct filter_params{
	double time_step; 
        double timeout_secs;
        int init_ticks;
        double alpha, beta,gamma;
	char *name;
} *filter_params_t;

/* streamlined alpha-beta-gamma filter.  User must supply his own a-b-c.  I have formulae
for them, probably should supply the ancillary routines to help out */

/* This  supports the Noisy ABC filter, with slots in the f_parms for noise value
that is to be added to the PREDICTION INTERVAL.  So if it thinks it's predicting
at one advance, really it goes to another advance via addition of noise.
Hmm...Should I discretize the noise to ticks?  I think so... */


/* note that if we supplied lambda, then alpha and beta are determined, and
we would hjave a reasonable # of parameters, wouldn't ahve to worry with this struct */

/* the idea of the struct is to simplify the calls, which otherwise
get cluttered up with lots of parameters.  On the other hand this means
the user has to do a lot more work...maybe need another layer to protect him.
Another aspect is that the user has to allocate these records and pass them
into filter, but they really belong to the filter, who can delete them.  Not
so nice --- they really should physically  live in the filter...what to do?? */

typedef struct abc_filter{
	struct filter_params f_params;
	int timeout_ticks;
	char name[32];
	double timeout_secs;
	double xlast, xcurr, vlast, vcurr, vave;  /*for the a-b filter calc.*/
	double xave, alast, acurr, aave;  /* for a-b-c calc. */
	double x_pred, v_pred, a_pred, innov; 
	double N;
	double alpha,beta,gamma;
	filter_activity activity;
	double x_est, v_est, a_est;    /*estimated variable */
	double x_future, v_future, a_future; /*predicted variable at time advance in the future;*/
					/*noisy of course ...heh heh */
	int age_ticks;		/* total age; */
	double age_secs;		/* total age; */
	int data_ticks; /*how long we've seen target*/
	double data_secs; /*how long we've seen target */
	int nodata_ticks; /* how long we've not seen target */
	double nodata_secs; /* how long we've not seen target */
    } *abc_filter_t;

extern abc_filter_t  abcfilter(/*filter_params parms*/);  /*create and init*/
extern void run(/*data_type signal, double x, double advance, double timestamp*/);
extern int abc_dump();


#endif





