#ifndef _cbtypes_h
#define _cbtypes_h

/********** axis codes for rotation matrices *******/
#define X_AXIS 0
#define Y_AXIS 1
#define Z_AXIS 2

/************vector row codes ***********/
#define X 0
#define Y 1
#define Z 2

/*************these for mat_add and qmat_add.  ZERO is a bit weird***/
#define PLUS 1.0
#define MINUS -1.0
#define ZERO 0.0

/*******************these for lud stuff****************/
#define TINY (1.0e-20)
#define SMALL (1.0e-10)

/*********************general matrix types ***************/
typedef double *dvec;
typedef int *ivec;
typedef double **dmat;

typedef struct matrix {
	int r;
	int c;
	dmat mat;
	} *matrix_t;

/*******************extern hack ***************/

#define EXTERN extern
#define TRUE	-1
#define FALSE	0

// char *malloc();
// FILE *fopen();

#endif

